unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  Spielfeld:array of integer;   //Spielfeld
  Gleich:array of boolean;      //Wenn Gleich, dann beim zeichnen des Feldes diese Karten aufdecken
  position1,position2:integer;  //Positionen zum Mausklick1 und Mausklick2

implementation

{$R *.lfm}

{ TForm1 }

procedure zeichnefeld;
var
  zeilen,spalten,i,j,pos:integer;
begin
  zeilen:=trunc(sqrt(high(spielfeld)));                    //im Idealfall ein quadratisches Feld -> Wurzel aus Karten ziehen
  spalten:=zeilen;

  if spalten*zeilen<=high(spielfeld) then inc(Spalten);     //Falls keine quadratische Form, muss zusätzlich eine Spalte eingefügt werden
  if spalten*zeilen<=high(spielfeld) then inc(Zeilen);      //Falls Spielfeld noch nicht reicht, muss zusätzlich eine Zeile eingefügt werden

  Form1.Stringgrid1.RowCount:=Zeilen;
  Form1.Stringgrid1.ColCount:=Spalten;

//  for i:=0 to Form1.Stringgrid1.RowCount-1 do
//    for j:=0 to Form1.Stringgrid1.ColCount-1 do
//      if i*Form1.Stringgrid1.ColCount+j<=high(Spielfeld) then Form1.Stringgrid1.Cells[j,i]:=inttostr(Spielfeld[i*Form1.Stringgrid1.ColCount+j]);

  for i:=0 to Zeilen-1 do
    for j:=0 to Spalten-1 do begin
      pos:=i*Spalten+j;
      if pos<=high(spielfeld) then
        if Gleich[pos] then Form1.Stringgrid1.Cells[j,i]:=inttostr(spielfeld[pos])
                       else Form1.Stringgrid1.Cells[j,i]:='O';

      if position1=pos then Form1.Stringgrid1.Cells[j,i]:=inttostr(spielfeld[pos]);
      if position2=pos then Form1.Stringgrid1.Cells[j,i]:=inttostr(spielfeld[pos]);

    end;
end;

procedure vergibKarten;
var
  i,j:integer;
begin
  for i:=0 to high(Spielfeld) do Spielfeld[i]:=-1; //Erstmal alle Felder auf "neutral" stellen
  for i:=0 to high(spielfeld) do begin             //Jetzt per Zufall jeweils zwei Karten (in diesem Fall Zahlen) im Spielfeld verstecken

    j:=random(high(Spielfeld)+1);
    while Spielfeld[j]>-1 do if j>=high(Spielfeld) then j:=0
                                                   else inc(j);
    Spielfeld[j]:=i div 2 + 1;                     //Ab der 1 beginnen, immer paarweise Karten per Zufall vergeben!
  end;

  for i:=0 to high(Spielfeld) do Gleich[i]:=false; //bisher gleicht kein Feld dem andern

  Position1:=-1;                                   //keine Position vergeben
  Position2:=-1;
end;

procedure TForm1.Edit1Change(Sender: TObject);
var
  i:integer;
begin
  TryStrToInt(edit1.Text,i);
  if i<2 then i:=2;
  Setlength(Spielfeld,i*2);
  Setlength(Gleich,i*2);
  VergibKarten;
  Zeichnefeld;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//  Randomize;
  edit1.Text:='8';
  Setlength(Spielfeld,16);
  Setlength(Gleich,16);
  VergibKarten;
  Zeichnefeld;
end;

procedure TForm1.StringGrid1Click(Sender: TObject);
var
  pos,i:integer;
begin
  pos:=Stringgrid1.Row*Form1.Stringgrid1.ColCount+Stringgrid1.Col;
  if pos>high(Spielfeld) then pos:=-1;             //Geht nicht zu nehmen, da Position größer als Spielfeld!
  if pos=position1 then pos:=-1;                   //Geht nicht zu nehmen, da schon geklickt!
  if pos=position2 then pos:=-1;                   //Geht nicht zu nehmen, da schon geklickt!
  if pos>-1 then if Gleich[Pos] then Pos:=-1;      //Geht nicht zu nehmen, da bereits aufgedeckt!

  if Pos>-1 then begin
    Form1.Caption:='Pos['+inttostr(pos)+'] - Wert['+inttostr(Spielfeld[pos])+']';
    if position1=-1 then Position1:=Pos
    else begin
      Position2:=Pos;
      if Spielfeld[Position2]=Spielfeld[Position1] then begin
        Gleich[Position1]:=true;
        Gleich[Position2]:=true;

        i:=0;
        while (i<high(Gleich)) and (Gleich[i]) do inc(i);
        if i=high(Gleich) then begin
          for i:=0 to 19 do begin
            Form1.Caption:='! ! ! Gewonnen ! ! !';
            Form1.Refresh;
            sleep(50);
            Form1.Caption:=' ! !  Gewonnen  ! ! ';
            Form1.Refresh;
            sleep(50);
          end;
          Form1.Edit1Change(nil);
        end;

      end else begin
        Zeichnefeld;
        Stringgrid1.Refresh;
        sleep(500);
      end;

      Position1:=-1;
      Position2:=-1;
    end;
  end else Form1.Caption:='Pos['+inttostr(pos)+'] - geht nicht';
  Zeichnefeld;
end;



end.

